import { ComponentRender, IComponentEvents } from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { IListPicker } from './IListPicker';

export class ListPickerClass extends ComponentRender implements IListPicker {
  public events!: IComponentEvents<IEventParam<any>>;

  public firstFilter: string = 'Primeiro filtro';

  public secFilter: string = 'Segundo filtro';

  public type: string = 'simple';

  public valueToDisplay = (option: any) => option;

  public elementValue = (option: any) => option;

  public dataText: string = '';

  public dataValue: string = '';

  public datasource: any = {};

  public data: any = [];

  public value: any = [];

  constructor(props: IListPicker) {
    super(props);
    this.firstFilter = this.getInitValue('firstFilter', props.firstFilter, this.firstFilter);
    this.secFilter = this.getInitValue('secFilter', props.secFilter, this.secFilter);
    this.type = this.getInitValue('type', props.type, this.type);
    this.valueToDisplay = this.getInitValue('valueToDisplay', props.valueToDisplay, this.valueToDisplay);
    this.elementValue = this.getInitValue('elementValue', props.elementValue, this.elementValue);
    this.dataText = this.getInitValue('dataText', props.dataText, this.dataText);
    this.dataValue = this.getInitValue('dataValue', props.dataValue, this.dataValue);
    this.datasource = this.getInitValue('datasource', props.datasource, this.datasource);
    this.data = this.getInitValue('data', props.data, this.data);
    // this.value = this.getInitValue('value', props.value, this.value);
    this.createAccessors();
  }

  public change() {
    if (this.events.change && typeof this.events.change === 'function') {
      this.events.change({ component: this });
    }
  }
}
